package org.expeditee.items.widgets;

import org.expeditee.core.Image;
import org.expeditee.gio.EcosystemManager;
import org.expeditee.gio.EcosystemManager.Ecosystem;
import org.expeditee.gio.javafx.JavaFXMiscManager;
import org.expeditee.items.Text;

import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.SnapshotParameters;
import javafx.scene.image.WritableImage;

public abstract class JavaFXWidget extends Widget {
	
	protected Scene _dummyScene;
	protected Node _node;

	protected JavaFXWidget(Text source, Node jfxNode, int minWidth, int maxWidth, int minHeight, int maxHeight)
	{
		super(source, minWidth, maxWidth, minHeight, maxHeight);
		_node = jfxNode;
		_dummyScene = new Scene(new Group(_node));
		onSizeChanged();
	}
	
	@Override
	public boolean isSupportedOnEcosystem(Ecosystem type)
	{
		return type == Ecosystem.JavaFX;
	}

	@Override
	public void paintWidget()
	{
		SnapshotParameters params = new SnapshotParameters();
		WritableImage snapshot = _node.snapshot(params, null);
		Image image = JavaFXMiscManager.getIfUsingJavaFXImageManager().createImage(snapshot);
		EcosystemManager.getGraphicsManager().drawImage(image, getPosition());
	}
	
	@Override
	protected void onMoved()
	{
		// Do nothing
	}
	
	@Override
	protected void onSizeChanged()
	{
		_dummyScene.getRoot().resize(getWidth(), getHeight());
		_node.resize(getWidth(), getHeight());
	}
}
